package it.micegroup.gestioneferie.pianificazioneferie.service;

import java.util.Map;
import java.util.List;
import java.util.Locale;
import java.util.HashMap;
import java.util.Optional;
import java.util.ArrayList;
import java.util.Collection;
import java.util.ResourceBundle;

import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;

import org.springframework.context.i18n.LocaleContextHolder;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import net.sf.jasperreports.engine.JRParameter;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiRichAdesionePf;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiRichAdesionePfKey;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiRichAdesionePf_;
import it.micegroup.gestioneferie.pianificazioneferie.criteria.DstatiRichAdesionePfCriteria;
import it.micegroup.gestioneferie.pianificazioneferie.repository.DstatiRichAdesionePfRepository;
import it.micegroup.voila2runtime.specification.FilterService;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiRichAdesionePf_;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiRichAdesionePfKey_;
import lombok.RequiredArgsConstructor;
import it.micegroup.gestioneferie.libs.service.BaseServiceImpl;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiRichAdesionePfKey_;

import java.util.stream.Collectors;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DrichAdesionePf;
import it.micegroup.voila2runtime.entity.GenericEntity;
import it.micegroup.voila2runtime.exception.BusinessException;
import net.sf.jasperreports.engine.JRException;

@RequiredArgsConstructor
@Service
@Transactional
public class DstatiRichAdesionePfServiceImpl extends BaseServiceImpl implements DstatiRichAdesionePfService {

	private final DstatiRichAdesionePfRepository dstatiRichAdesionePfRepository;
	private final FilterService<DstatiRichAdesionePf> filterService;

	// CHILD SERVICES
	private final DrichAdesionePfService drichAdesionePfService;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DstatiRichAdesionePfServiceImpl.class);

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findAll(org. springframework.data.domain.Pageable)
	 */
	@Override
	@Transactional(readOnly = true)
	public Page<DstatiRichAdesionePf> findAll(Pageable pageable) {
		return dstatiRichAdesionePfRepository.findAll(pageable);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findAll()
	 */
	@Override
	@Transactional(readOnly = true)
	public List<DstatiRichAdesionePf> findAll() {
		return dstatiRichAdesionePfRepository.findAll();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findByCriteria(java. lang.Object, org.springframework.data.domain.Pageable)
	 */
	@Override
	@Transactional(readOnly = true)
	public Page<DstatiRichAdesionePf> findByCriteria(DstatiRichAdesionePfCriteria criteria, Pageable pageable) {
		final Specification<DstatiRichAdesionePf> specification = createSpecification(criteria);
		return dstatiRichAdesionePfRepository.findAll(specification, pageable);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findByCriteria(java. lang.Object)
	 */
	@Override
	@Transactional(readOnly = true)
	public List<DstatiRichAdesionePf> findByCriteria(DstatiRichAdesionePfCriteria criteria) {
		final Specification<DstatiRichAdesionePf> specification = createSpecification(criteria);
		return dstatiRichAdesionePfRepository.findAll(specification);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findById(java.lang. Object)
	 */
	@Override
	@Transactional(readOnly = true)
	public Optional<DstatiRichAdesionePf> findById(DstatiRichAdesionePfKey id) {
		return dstatiRichAdesionePfRepository.findByDstatiRichAdesionePfKey(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * exists(java.lang. Object)
	 */
	@Override
	public boolean exists(DstatiRichAdesionePfKey id) {
		return dstatiRichAdesionePfRepository.existsById(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * insert(java. lang.Object)
	 */
	@Override
	public DstatiRichAdesionePf insert(@Valid DstatiRichAdesionePf entity) {
		return dstatiRichAdesionePfRepository.save(entity);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * update(java. lang.Object)
	 */
	@Override
	public DstatiRichAdesionePf update(@Valid DstatiRichAdesionePf entity) {
		return dstatiRichAdesionePfRepository.save(entity);
	}

	@Override
	public void delete(DstatiRichAdesionePf entity) {
		dstatiRichAdesionePfRepository.delete(entity);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * deleteById(java.lang. Object)
	 */
	@Override
	public void deleteById(DstatiRichAdesionePfKey id) {
		dstatiRichAdesionePfRepository.deleteById(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * deleteByIdIn(java.lang. Object)
	 */
	@Override
	public void deleteByIdIn(Collection<DstatiRichAdesionePfKey> ids) {
		dstatiRichAdesionePfRepository.deleteByIdIn(ids);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findByObjectKey(java.lang.String)
	 */
	@Override
	@Transactional(readOnly = true)
	public Optional<DstatiRichAdesionePf> findByObjectKey(String id) {
		DstatiRichAdesionePf dstatiRichAdesionePf = new DstatiRichAdesionePf(id);

		return findById(dstatiRichAdesionePf.getDstatiRichAdesionePfKey());
	}

	/**
	 * Convert DstatiRichAdesionePfCriteria to a {@link Specification}
	 * 
	 * @param criteria
	 * @return
	 */
	private Specification<DstatiRichAdesionePf> createSpecification(DstatiRichAdesionePfCriteria criteria) {
		Specification<DstatiRichAdesionePf> specification = Specification.where(null);

		if (criteria != null) {
			// Attribute filters
			if (criteria.getSequIdStatoRichAdesionePf() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getSequIdStatoRichAdesionePf(), DstatiRichAdesionePf_.sequIdStatoRichAdesionePf));
			}
			if (criteria.getCodiStatoRichiestaAdes() != null) {
				specification = specification.and(filterService.generateStringSpecification(
						criteria.getCodiStatoRichiestaAdes(), DstatiRichAdesionePf_.codiStatoRichiestaAdes));
			}
			if (criteria.getDescStatoRichiestaAdes() != null) {
				specification = specification.and(filterService.generateStringSpecification(
						criteria.getDescStatoRichiestaAdes(), DstatiRichAdesionePf_.descStatoRichiestaAdes));
			}
			if (criteria.getFlagEliminato() != null) {
				specification = specification.and(filterService.generateStringSpecification(criteria.getFlagEliminato(),
						DstatiRichAdesionePf_.flagEliminato));
			}
			if (criteria.getUtenteUltimaModifica() != null) {
				specification = specification.and(filterService.generateStringSpecification(
						criteria.getUtenteUltimaModifica(), DstatiRichAdesionePf_.utenteUltimaModifica));
			}
			if (criteria.getDataUltimaModifica() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getDataUltimaModifica(), DstatiRichAdesionePf_.dataUltimaModifica));
			}
			if (criteria.getDataInizioRecord() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getDataInizioRecord(), DstatiRichAdesionePf_.dataInizioRecord));
			}
			if (criteria.getDataFineRecord() != null) {
				specification = specification.and(filterService.generateRangeSpecification(criteria.getDataFineRecord(),
						DstatiRichAdesionePf_.dataFineRecord));
			}

			// CompositeKey Filters

		}
		return specification;
	}

	@Override
	@Transactional()
	public DstatiRichAdesionePf bulkUpdate(DstatiRichAdesionePf dstatiRichAdesionePf) {
		List<DrichAdesionePf> updateTheDrichAdesionePf = dstatiRichAdesionePf.getTheDrichAdesionePf().stream()
				.filter(child -> !child.isDeletedEntityState()).collect(Collectors.toList());
		List<DrichAdesionePf> deleteTheDrichAdesionePf = dstatiRichAdesionePf.getTheDrichAdesionePf().stream()
				.filter(GenericEntity::isDeletedEntityState).collect(Collectors.toList());

		dstatiRichAdesionePf.setTheDrichAdesionePf(updateTheDrichAdesionePf);

		DstatiRichAdesionePf update = this.update(dstatiRichAdesionePf);

		deleteTheDrichAdesionePf.forEach(child -> drichAdesionePfService.deleteById(child.getDrichAdesionePfKey()));
		return update;
	}
}
